/******************************************************************************/
//
// Name: 	Interfacing ADSP-21161 with AD7865 
//
/******************************************************************************

(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		ADSP-21161_with_AD7865.asm

Date Modified:	11/05/04				Rev 1.0

Software:       VisualDSP++3.5 (September update)

Purpose:		To receive data from AD7865
				
*******************************************************************************/

#include <def21161.h>

.section/pm seg_rth;
	nop;nop;nop;nop;
	nop;jump start;nop;nop;
	rti;rti;rti;rti;
	rti;rti;rti;rti;
	rti;rti;rti;rti;
	rti;rti;rti;rti;
	rti;rti;rti;rti;
	jump irq_isr; rti;rti;rti;
	
.section/dm seg_ext;
	.var adc_data;
	
.section/dm seg_dmda;
	.var channel1_data;
	.var channel2_data;
	.var channel3_data;
	.var channel4_data;
	
.section/pm seg_pmco;
start:
	
	bit set mode2 IRQ1E;
	nop;nop;nop;nop;
	bit clr irptl IRQ1I;
	bit set imask IRQ1I;
	bit set mode1 IRPTEN;
	
	r0 = 0x0;
	dm(SPCTL0) = r0;
	
	r0 = 0x1f001f;
	dm(DIV0) = r0;
	
	// Dummy write to initiate TFS
	r0 = 0xaaaaaaaa;
	dm(TX0A) = r0;
	
	r0 = SPEN_A | SLEN32 | ICLK | IFS | FSR | DITFS | LFS | DDIR;
	dm(SPCTL0) = r0;
		
	r1 = 0x3fff;
	nop;
	nop;
	jump(pc,0);
	
irq_isr:
	nop;
	r0 = dm(adc_data);
	r0 = r0 and r1;
	dm(channel1_data) = r0;
	nop;nop;nop;nop;nop;
	
	r0 = dm(adc_data);
	r0 = r0 and r1;
	dm(channel2_data) = r0;
	nop;nop;nop;nop;nop;
	
	r0 = dm(adc_data);
	r0 = r0 and r1;
	dm(channel3_data) = r0;
	nop;nop;nop;nop;nop;
	
	r0 = dm(adc_data);
	r0 = r0 and r1;
	dm(channel4_data) = r0;
	nop;
	rti;
