/******************************************************************************/
//
// Name: 	Interfacing ADSP-21161 with AD7865 
//
/******************************************************************************

(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		ADSP-21161_with_AD7865_DMA.asm

Date Modified:	11/05/04				Rev 1.0

Software:       VisualDSP++3.5 (September update)

Purpose:		To receive data from AD7865
				
*******************************************************************************/

#include <def21161.h>

.section/pm seg_rth;
	nop;nop;nop;nop;
	nop;jump start;nop;nop;

.section/pm seg_ep;
	jump ep_isr;rti;rti;rti;
		
.section/dm seg_dmda;
	.var channel_data[4];
	.var masked_channel_data[4];
	.var tcb[8] = {4,0,0x8000000,0,tcb+7,4,1,channel_data-0x40000};
	
.section/pm seg_pmco;
start:
	bit set imask EP1I;
	bit set mode1 IRPTEN;
	
	r0 = 0x0;
	dm(DMAC11) = r0;
	
	// Initializing DMA
	r0 = MASTER | HSHAKE | DEN | CHEN | PMODE4 | INT32;
	dm(DMAC11) = r0;
	
	// Loading chain pointer
	r0 = tcb+7-0x40000;
	dm(CPEP1) = r0;
	
	r0 = 0x0;
	dm(SPCTL0) = r0;
		
	r0 = 0x1f001f;
	dm(DIV0) = r0;
	
	// Dummy write to initiate TFS
	r0 = 0xaaaaaaaa;
	dm(TX0A) = r0;
	
	r0 = SPEN_A | SLEN32 | ICLK | IFS | FSR | DITFS | LFS | DDIR;
	dm(SPCTL0) = r0;
		
	r1 = 0x3fff;
	nop;
	nop;
	jump(pc,0);
	
ep_isr:
	r1 = 0x3fff;
	i0 = channel_data;
	i1 = masked_channel_data;
	m0 = 1;
	
	lcntr = 4, do mask until lce;
		r0 = dm(i0,m0);
		r0 = r0 and r1;
mask:		dm(i1,m0) = r0;
	rti;
	
